//
// 3D Game Programming
// NCTU
// Instructor: SAI-KEUNG WONG
//
#include "TutorialApplication.h"

using namespace Ogre;
BasicTutorial_00::BasicTutorial_00(void) {}

void BasicTutorial_00::createScene(void) 
{
	mSceneMgr->setAmbientLight( ColourValue( 0.5, 0.5, 0.5 ) ); 
	//mSceneMgr->setAmbientLight( ColourValue( 1, 1, 1 ) );  
	mSceneMgr->setShadowTechnique(
		SHADOWTYPE_STENCIL_ADDITIVE); 

	Light *light = mSceneMgr->createLight("Light1"); 
	light->setType(Light::LT_POINT); 
	light->setPosition(Vector3(0, 150, 250)); 
	light->setDiffuseColour(1.0, 1.0, 1.0);		//red
	light->setSpecularColour(1.0, 1.0, 1.0);	//red


	mTargetEntity 
		= mSceneMgr
		->createEntity( "Robot", "robot.mesh" ); 

	mTarget
		= mSceneMgr
		->getRootSceneNode()
		->createChildSceneNode( 
		"RobotNode", Vector3( 50, 0, 0 ) ); 

	mTarget->attachObject( mTargetEntity );
	//
	int i;
	i = 0;
	mCharEntity[i] 
	= mSceneMgr
		->createEntity( "c0", "sphere.mesh" ); 

	mChar[i]
	= mSceneMgr
		->getRootSceneNode()
		->createChildSceneNode( 
		"c0", Vector3( 200, 0, 100 ) ); 

	mChar[i]->attachObject( mCharEntity[i] );
	mCharVelocity[i] = Vector3(0, 0, 80);
	mChar[i]->scale(0.1, 0.1, 0.1);
	//
	Plane plane(Vector3::UNIT_Y, 0); 
	MeshManager::getSingleton().createPlane(
		"ground", 						ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, 
		plane, 
		1500,1500, 	// width, height
		20,20, 		// x- and y-segments
		true, 		// normal
		1, 		// num texture sets
		5,5, 		// x- and y-tiles
		Vector3::UNIT_Z	// upward vector
		); 

	Entity *ent = mSceneMgr->createEntity(
		"GroundEntity", "ground"); 
	mSceneMgr
		->getRootSceneNode()
		->createChildSceneNode()
		->attachObject(ent); 

}

bool BasicTutorial_00::frameRenderingQueued(const Ogre::FrameEvent& evt)
{
	bool flg = BaseApplication::frameRenderingQueued(evt);

	
	Vector3 charPos;
	int i;
	Real t = evt.timeSinceLastFrame; // time step
	i = 0;

	charPos  = mChar[i]->getPosition();
	Vector3 targetPos = mTarget->getPosition();
	Vector3 direction = targetPos - charPos;
	Real m = 1.0;
	direction.normalise(); //unit vector
	Vector3 force = 30*direction; // constant force magnitude = 30

	mCharVelocity[i] = mCharVelocity[i] + force/m*t;
	charPos = charPos + mCharVelocity[i]*t;
	mChar[i]->setPosition(charPos);

	return flg;
}

int main(int argc, char *argv[]) {
	BasicTutorial_00 app;
	app.go();  
	return 0;
}
